;---     8048 -----

; reset vector
 .org  0
start:
  dis   i      ; disable interrupts
  jmp  main

; external interrupt vector
 .org  3
intr:
  jmp  intr   ;

; timer interrupt vector
 .org  7
time:
  jmp  time   ;

main:
  mov  r0,#0  ;   
  call play   ;  
  clr  a      ; ,   
  outl p1,a   ;    1
  call onesec ;  2 
  call onesec
  jmp  main

;---------------------
play:
  mov  a,r0   ;   
  add  a,#TB1 ;  
  movp a,@a   ; Move from memory A=[PC<11:8>+A]
  orl  a,#0   ; - -
  jnz  doit
  ret
doit:
  mov  r2,a   ; 
  mov  r3,a
  mov  a,#30H ; 0011.0000b
  mov  r4,#0  ;  P1.4,P1.5  P1.6,P1.7    
  mov  r5,#2AH;  ""
K04:
  outl p1,a   ;    1
  djnz r2,K05 ;
  mov  r6,a
  mov  a,r3
  mov  r2,a
  mov  a,r6
  xrl  a,#0F0H;   
K05:
  djnz r4,K04 ;
K06:
  djnz r5,K04 ;
  inc  r0     ;    
  jmp  play

;------   -    --------------------------
;------    ,  ,  - 
TB1:
    .DB  #51H
    .DB  #3CH
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #4CH ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #4CH ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #4CH ;
    .DB  #39H ;
    .DB  #2DH ;
    .DB  #4CH ;
    .DB  #39H ;
    .DB  #2DH ;
    .DB  #51H
    .DB  #40H ;
    .DB  #2DH ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #36H ;
    .DB  #5BH ;
    .DB  #40H ;
    .DB  #36H ;
    .DB  #66H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #51H ;
    .DB  #3CH
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #28H ;
    .DB  #3CH ;
    .DB  #28H ;
    .DB  #28H ;
    .DB  #36H ;
    .DB  #2DH ;
    .DB  #51H ;
    .DB  #36H ;
    .DB  #2DH ;
    .DB  #51H ;
    .DB  #36H ;
    .DB  #2DH
    .DB  #28H ;
    .DB  #36H ;
    .DB  #28H ;
    .DB  #28H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #3CH ;
    .DB  #33H ;
    .DB  #26H ;
    .DB  #3CH ;
    .DB  #2DH ;
    .DB  #4CH ;
    .DB  #3CH ;
    .DB  #2DH ;
    .DB  #28H
    .DB  #40H ;
    .DB  #33H ;
    .DB  #51H ;
    .DB  #40H ;
    .DB  #33H ;
    .DB  #2DH ;
    .DB  #40H ;
    .DB  #36H ;
    .DB  #20H ;
    .DB  #40H ;
    .DB  #36H ;
    .DB  #3DH ;
    .DB  #79H ;
    .DB  #3DH ;
    .DB  #00H ;

;---------------------
onesec:
  mov  r3,#10
loop_d:
  call delay100
  djnz r3,loop_d
  ret

;---------------------
delay100:
   mov  r6,#84
loopex:
   mov  r2,#236
loopin:
   djnz r2,loopin
   djnz r6,loopex
   mov  r6,#4
loopad:
   djnz r6,loopad
   ret

